static char * sccsid = "@(#)  check.c  (v1.7 3/15/90)";
/*
 * Check various conditions on kef-db structures.
 * Routines here:
 *
 * kef_check (f, kdb)
 */

# include <stdio.h>
# include "kef.h"

extern int kef__is_clean ();

	static int
check1 (f, kdb)
	FILE * f;
	struct kef_db * kdb;
/*
 * Check for each node with follow nodes, whether they are really
 * sorted and unique.
 */
{
	static char * I = "check1 ::";
	register int i, j;
	int num;
	unsigned char b;

	num = 0;
	for (i = 0; i < kdb->high_nodes; i++) {
		if (IS_FREE(kdb->node[i]) || kdb->node[i].sub == KEF_NIL)
			continue;
		j = kdb->node[i].sub;
		b = kdb->node[j].what;
		while ((j = kdb->node[j].next) != KEF_NIL) {
			if (b >= kdb->node[j].what) {
				fprintf (f, "%s list below node %1d not sorted at node %1d\n",
					I, i, j);
				num ++;
				break;
			}
			b = kdb->node[j].what;
		}
	}
	if (num == 0)
		return KEF_E_OK;
	else
		return KEF_E_CHECK;
}
	static int
check2 (f, kdb)
	FILE * f;
	struct kef_db * kdb;
/*
 * Check the CLEAN flag for all elements.
 */
{
	static char * I = "check2 ::";
	register int i, j;
	int num = 0;

	for (i = 0; i < kdb->high_nodes; i++) {
		if (IS_FREE(kdb->node[i]) || kdb->node[i].sub == KEF_NIL)
			continue;
		j = kef__is_clean (kdb, i);

		if (IS_CLEAN(kdb->node[i])) {
			if (j == 0) {
				fprintf (f, "%s ERROR CLEAN flag set, but array not clean at %1d\n",
					I, i);
				num ++;
			}
		} else {
			if (j == 1) {
				fprintf (f, "%s WARNING CLEAN flag not set, but should be at %1d\n",
					I, i);
				num ++;
			}
		}
	}
	if (num == 0)
		return KEF_E_OK;
	else
		return KEF_E_CHECK;
}

kef_check_db (f, kdb)
	FILE * f;
	struct kef_db * kdb;
/*
 * Return KEF_E_OK if everything was ok, else KEF_E_CHECK.
 * Messages are printed on file f.
 */
{
	int i, j;

	i = KEF_E_OK;
	i = check1 (f, kdb);
	j = check2 (f, kdb);
	if (i == KEF_E_OK)
		i = j;

	return i;
}
