static char * sccsid = "@(#)  match.c  (v1.5 3/13/90)";

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_MATCH
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

	int
kef_match (kdb, str, val)
	struct kef_db * kdb;
	char * str;
	kef_value * val;
/*
 * Does string str match a string in kef database kdb?
 * returns : 0 : no, 1 : yes + val contains value
 *
 * Bugs: Does not work with strings containing '\0'. But then what
 * does ?
 */
{
	DI("kef__match ::")
	register int i, j;
	kef_index pos, new_pos;

	DEB2("%s called for '%s'\n", str);
	FLUSH;
	if (str [0] == '\0')
		return 0;		/* A special case */

	/*
	 * Is the first character in the set of
	 * start characters ?
	 */
	j = kef__locate_node (kdb->node, str[0],
			(kef_index) (kdb->root), &pos);
	DEB3("%s locate of first character returned %1d; pos = %1d\n", j, pos);
	if (j == 0)
		return 0;
	if (pos == KEF_NIL)
		pos = kdb->node[kdb->root].sub;
	else
		pos = kdb->node[pos].next;

	for (i = 1; str [i] != '\0'; i++) {
		DEB3("%s locate node for '%c' below %1d\n", str[i], pos);
		FLUSH;
		j = kef__locate_node (kdb->node, str[i], pos, &new_pos);
		DEB3("%s search returned %1d, pos = %1d\n", j, new_pos);
		FLUSH;
		if (j == 0)
			break;
		if (new_pos == KEF_NIL)
			pos = kdb->node[pos].sub;
		else
			pos = kdb->node[new_pos].next;
	}
	DEB3("%s last char %s NUL; pos = %1d\n",
		str[i] == '\0' ? "==" : "!=", pos);
	DEB3("%s match of '%s' results %d\n",
		str, str[i] == '\0' && HAS_VALUE(kdb->node[pos]));

	if (str[i] == '\0' && HAS_VALUE(kdb->node[pos])) {
			*val = kdb->node[pos].value;
			return 1;
	}
	*val = 0;
	return 0;
}
